/* name:    varswap.cxx
   author:  Leo Liberti
   purpose: demonstration of templates on simple swapping algorithm
   source:  GNU C++ 4.1.2
   history: 080218 work started
*/

#include <iostream>
#include <string>

class MyClass {
public:
  MyClass(std::string t) : myString(t) { }
  ~MyClass() { }
  std::string getString(void) { return myString; }
  void setString(std::string& t) { myString = t; }
private:
  std::string myString;
};

std::ostream& operator<<(std::ostream& outStream, MyClass& t) {
  outStream << t.getString();
  return outStream;
}

template<class T> void varSwap(T& a, T& b) {
  T tmp(b);
  b = a;
  a = tmp;
}

int main(int argc, char** argv) {
  using namespace std;
  int ret = 0;

  int ia, ib;
  double da, db;

  ia = 1;
  ib = 2;
  cout << "before varSwap: ia = " << ia << "; ib = " << ib << endl;
  varSwap(ia, ib);
  cout << "after varSwap : ia = " << ia << "; ib = " << ib << endl;

  da = 1.1;
  db = 2.2;
  cout << "before varSwap: da = " << da << "; db = " << db << endl;
  varSwap(da, db);
  cout << "after varSwap : da = " << da << "; db = " << db << endl;

  MyClass ma("get"), mb("in");
  cout << "before varSwap: " << ma << " " << mb << endl;
  varSwap(ma, mb);
  cout << "after varSwap : " << ma << " " << mb << endl;

  return ret;
}
